#ifndef MAXENT_C_H
#define MAXENT_C_H

/* Structure declarations */

typedef void* moments_c;
typedef void* multipliers_c;
typedef void* maxent_c;

/* Function declarations */

/* Moments */

moments_c moment_set_dim_pow (int d, int p);

int moment_copy(moments_c from, moments_c to);

int moment_get_dim (moments_c);

int moment_get_pow (moments_c);

int moment_get_size (moments_c);

double moment_get_value(moments_c, int *);

int moment_set_value(moments_c, int *, double value);

int moment_print (moments_c, FILE *);

void moment_free(moments_c);

/* Multipliers */

multipliers_c multiplier_init ();

int multiplier_copy(multipliers_c from, multipliers_c to);

int multiplier_get_dim (multipliers_c);

int multiplier_get_pow (multipliers_c);

int multiplier_get_size (multipliers_c);

double multiplier_get_value(multipliers_c, int *);

double multiplier_get_poly_value(multipliers_c, double *);

int multiplier_print (multipliers_c, FILE *);

void multiplier_free(multipliers_c);

/* Maxent */

maxent_c maxent_set_quad_size (int s);

int maxent_set_tol(maxent_c, double tol);

int maxent_info(maxent_c, int i); // set nonzero for stdin info output

int maxent_compute(maxent_c, moments_c, multipliers_c);

void maxent_free(maxent_c);

#endif /* MAXENT_C_H */
